datablock AudioProfile(RevolverShotSound)
{
   filename    = "./shoot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(RevolverMagout)
{
   filename    = "./magout.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(RevolverMagout2)
{
   filename    = "./magout2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(RevolverMagin)
{
   filename    = "./magin.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(RevolverMagin2)
{
   filename    = "./magin2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(RevolverHammer)
{
	filename = "./hammer.wav";
	description = AudioClose3d;
	preload = true;
};
AddDamageType("Revolver",   '%1 played Russian Roulette and lost.',    '%2 disproved the luck of %1.',0.2,1);
datablock ItemData(RevolverItem : utaItem)
{
	shapeFile = "./item.dts";
	uiName = "Revolver";
	iconName = "./icon_ui";
	image = RevolverImage;
	maxAmmo = 4;
};
datablock ShapeBaseImageData(RevolverImage : utaImage)
{
   className = "WeaponImage";
   shapeFile = "./gun.dts";
   armReady = true;
   item = RevolverItem;
   ammo = " ";
   projectile = utaProjectile;
   projectileType = Projectile;

   raycastWeaponRange = 90;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = utaProjectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 30; //Varies based on range
   raycastDirectDamageType = $DamageType::Revolver;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0;
   raycastTracerProjectile = "";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 140;
   raycastVerticalImpulse = 100;
   
   eyeOffset = "0.4 1.2 -0.25";


	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1.4;
	stateSequence[0] = "equip";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	
	stateName[20]                     = "Ready2";
	stateTransitionOnTriggerUp[20]  = "Ready";
	
	stateName[2]="Fire";
	stateTimeoutValue[2]=0;
	stateScript[2]                  = "onFire";
	stateEmitter[2]					= utaFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateFire[2]                    = true;
	stateTransitionOnTimeout[2]     = "Fire2";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= RevolverShotSound;
	
		stateName[18]="Fire2";
		stateTimeoutValue[18]=0.63;
		stateTransitionOnTimeout[18]="Fire3";
		
		stateName[19]="Fire3";
		stateTimeoutValue[19]=0.27;
		stateTransitionOnTimeout[19]="Delay";
		stateSound[19]=RevolverHammer;

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.01;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready2";
	stateTransitionOnNoAmmo[5]		= "Reload";

		stateName[6]				= "Reload";
		stateTimeoutValue[6]			= 0.00;
		stateSequence[6]                = "Reload";
		stateScript[6]				= "onReloadStart";
		stateTransitionOnTimeout[6]		= "Reload2";
		stateWaitForTimeout[6]			= true;
		
		stateName[13]				= "Reload2";
		stateTimeoutValue[13]			= 0.76;
		stateTransitionOnTimeout[13]		= "Reload3";
		
		stateName[14]				= "Reload3";
		stateTimeoutValue[14]			= 0.66;
		stateTransitionOnTimeout[14]		= "Reload4";
		stateSound[14]=RevolverMagout;
		
		stateName[15]				= "Reload4";
		stateTimeoutValue[15]			= 0.66;
		stateTransitionOnTimeout[15]		= "Reload5";
		stateSound[15]=RevolverMagout2;
		
		stateName[16]				= "Reload5";
		stateTimeoutValue[16]			= 0.53;
		stateTransitionOnTimeout[16]		= "Reload6";
		stateSound[16]=RevolverMagin;
		
		stateName[17]				= "Reload6";
		stateTimeoutValue[17]			= 0.39;
		stateTransitionOnTimeout[17]		= "Wait";
		stateSound[17]=RevolverMagin2;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.01;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	stateTransitionOnTimeout[10]		= "Ready2";
	
	stateName[11] 				= "ReloadSmoke";
	stateTransitionOnTimeout[11]		= "Reload";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";

};

function RevolverImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}

function RevolverImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function RevolverImage::onReloadStart(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function RevolverImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}

function RevolverImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function RevolverImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}
